#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "system.h"
#include "config.h"
#include "zip.h"
#include "gzip.h"
#include "bzip.h"
#include "ux.h"
#include "tar.h"
GtkWidget* DirTo=NULL;
GtkWidget* DirFrom=NULL;
GtkWidget* TempDir=NULL;
GtkWidget* stsFrom=NULL;
GtkWidget* FileSaveAs=NULL;
GtkWidget* FileOpenZipExe=NULL;
GtkWidget* FileOpenGzipExe=NULL;
GtkWidget* FileOpenBzipExe=NULL;
GtkWidget* FileOpenUxExe=NULL;
GtkWidget* FileOpenTarExe=NULL;
GtkWidget* Options=NULL;
//GtkWidget* Progress=NULL;
char* method="Zip";
void getOptions(GtkWidget*);
void setOptions(GtkWidget*);

void
on_mnuFile_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_mnuFileOpenFromDirectory_activate   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char cwd[1024];
  gdk_threads_enter();
  if(DirFrom==NULL)
	DirFrom=create_winOpenDirectory();
  getcwd(cwd,sizeof(cwd));
  getOpenDir(1,cwd,DirFrom,"DirFrom",0);
  gtk_window_set_title(GTK_WINDOW(DirFrom),_("Open Directory From"));
  gtk_widget_show(DirFrom);
  gdk_threads_leave();
}


void
on_mnuFileOpenToDirectory_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char cwd[1024];
  gdk_threads_enter();
  if(DirTo==NULL)
	DirTo=create_winOpenDirectory();
  getcwd(cwd,sizeof(cwd));
  getOpenDir(1,cwd,DirTo,"DirTo",0);
  gtk_window_set_title(GTK_WINDOW(DirTo),_("Open Directory To"));
  gtk_widget_show(DirTo);
  gdk_threads_leave();
}


void
on_mnuFileCompressOrSaveAs_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_mnuFileQuit_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  exit(0);
}


void
on_mnuOptionsSetOptions_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *Options;
  gdk_threads_enter();
  Options=create_winOptions();
  readFile();
  setOptions(Options);
  gtk_widget_show(Options);
  gdk_threads_leave();
}


void
on_mnuHelpAbout_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *About;
  gdk_threads_enter();
  About=create_dlgMessage();
  gtk_widget_show(About);
  gdk_threads_leave();
}


gboolean
on_btnAddOne_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  int i=1;
  char cwd[1024];
  char *pathFrom,*temp1,*temp2,result[1024],*buffer[2];
  GtkWidget* lstFrom=NULL;
  GtkWidget* lstTo=NULL;
  GtkWidget* lblFrom=NULL;
  lstFrom=lookup_widget(widget,"lstFrom");
  lstTo=lookup_widget(widget,"lstTo");
  lblFrom=lookup_widget(GTK_WIDGET(lstFrom),"lblFrom");
  for(i=0;i<selFrom->numrows+1;i++){
	if(selFrom[i].row==(int*)1){
	  gtk_label_get(GTK_LABEL(lblFrom),&pathFrom);
	  gtk_clist_get_text(GTK_CLIST(lstFrom),i,0,&temp1);
	  gtk_clist_get_text(GTK_CLIST(lstFrom),i,1,&temp2);
	  sprintf(result,"%s%s",pathFrom,temp1);
	  buffer[0]=result;
	  buffer[1]=temp2;
  	  gtk_clist_append(GTK_CLIST(lstTo),buffer);
	}
  }
  getcwd(cwd,sizeof(cwd));
  getFromDir(0,cwd,winMain,"winMain",0);
  memset(selFrom,0x0,sizeof(selFrom));
  selFrom->numrows=compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  for(i=0;i<selFrom->numrows;i++)
	selFrom[i].row=0;
  selTo->numrows=compareLists((GtkCList*)lstTo,(GtkCList*)lstFrom);
  for(i=0;i<selTo->numrows;i++)
	if(selTo[i].row!=(int*)1)
	  selTo[i].row=0;
  compareLists((GtkCList*)lstTo,(GtkCList*)lstFrom);
  return FALSE;
}


gboolean
on_btnAddAll_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  char *temp1;
  GtkWidget* lstFrom=NULL;
  lstFrom=lookup_widget(widget,"lstFrom");
  gtk_clist_select_all(GTK_CLIST(lstFrom));
  on_btnAddOne_button_press_event(widget,event,user_data);
  while(gtk_clist_get_text(GTK_CLIST(lstFrom),2,0,&temp1)){
	gtk_clist_select_all(GTK_CLIST(lstFrom));
	on_btnAddOne_button_press_event(widget,event,user_data);
  }
  return FALSE;
}


gboolean
on_btnRemoveOne_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  int i=1;
  char cwd[1024];
  GtkWidget* lstFrom=NULL;
  GtkWidget* lstTo=NULL;
  GtkWidget* lblFrom=NULL;
  lstFrom=lookup_widget(widget,"lstFrom");
  lstTo=lookup_widget(widget,"lstTo");
  lblFrom=lookup_widget(GTK_WIDGET(lstFrom),"lblFrom");
  for(i=selTo->numrows;i>-1;i--){
	if(selTo[i].row==(int*)1){
	  gtk_clist_remove(GTK_CLIST(lstTo),i);
	}
  }
  getcwd(cwd,sizeof(cwd));
  getFromDir(0,cwd,winMain,"winMain",0);
  memset(selFrom,0x0,sizeof(selFrom));
  selFrom->numrows=compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  for(i=0;i<selFrom->numrows;i++)
	selFrom[i].row=0;
  selTo->numrows=compareLists((GtkCList*)lstTo,(GtkCList*)lstFrom);
  for(i=0;i<selTo->numrows;i++)
	if(selTo[i].row!=(int*)1)
	  selTo[i].row=0;
  compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  return FALSE;
}


gboolean
on_btnSaveAs_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
//  GtkWidget *btnCompress;
  gdk_threads_enter();
//  btnCompress=lookup_widget(gtk_widget_get_toplevel(widget),"btnCompress");
  if(((!strcmp(method,"Tar"))&&(methods.tar.Exe!=NULL))||
    ((!strcmp(method,"Gzip"))&&(methods.gzip.Exe!=NULL))||
    ((!strcmp(method,"Bzip2"))&&(methods.bzip.Exe!=NULL))||  
    ((!strcmp(method,"Zip"))&&(methods.zip.Exe!=NULL))||
    ((!strcmp(method,"Unix Compress"))&&(methods.ux.Exe!=NULL))||
    ((!strcmp(method,"Tar + Gzip"))&&(methods.tar.Exe!=NULL)&&(methods.gzip.Exe!=NULL))){
	if(FileSaveAs==NULL){
	    FileSaveAs=create_fileSaveAs();
	    gtk_widget_show(FileSaveAs);
	}
  }
//  gtk_widget_hide(widget);
//  gtk_widget_show(btnCompress);
  
  gdk_threads_leave();
  return FALSE;
}


gboolean
on_btnOptions_button_press_event       (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  gdk_threads_enter();
  if(Options==NULL)
	Options=create_winOptions();
  readFile();
  setOptions(Options);
  gtk_widget_show(Options);
  gdk_threads_leave();
  return FALSE;
}


gboolean
on_btnExit_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  exit(0);
  return FALSE;
}


gboolean
on_optCompressionMethods_button_press_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_lstFrom_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  GtkWidget* popup=NULL;
  popup=create_popChangeDirectoryFrom();
  if(event->type==GDK_BUTTON_PRESS &&
	 event->button==3){
	gtk_menu_popup(GTK_MENU(popup),NULL,NULL,NULL,NULL,
				   event->button,event->time);
  }
  return FALSE;
}


gboolean
on_lblFilesFromNames_button_press_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_lblFilesFromSizes_button_press_event
                                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_lblFilesToNames_button_press_event  (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_lblFilesToSizes_button_press_event  (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_btnCompress_button_press_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_btnCreateDirectory_button_press_event
                                        (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_btnRemoveDirectory_button_press_event
                                        (GtkButton       *button,
                                        gpointer         user_data)
{

}


gboolean
on_optDirectories_button_press_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_inpDirectory_focus_out_event        (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_btnOpenDirectoryOk_pressed          (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget* inpDirectory=NULL;  
  GtkWidget* lblTo=NULL;
  GtkWidget* lstFrom=NULL;  
  GtkWidget* lstTo=NULL;  
  char cwd[1024];
  int i;
  gdk_threads_enter();
  inpDirectory=lookup_widget(GTK_WIDGET(button),"inpDirectory");
  lblTo=lookup_widget(winMain,"lblTo");
  lstFrom=lookup_widget(winMain,"lstFrom");
  lstTo=lookup_widget(winMain,"lstTo");
  if(gtk_widget_get_toplevel(GTK_WIDGET(button))==DirFrom){
	DirFrom=NULL;
	getcwd(cwd,sizeof(cwd));
	getFromDir(0,cwd,winMain,"winMain",0);
	on_lstFrom_click_column((GtkCList*)lstFrom,0,NULL);
  }
  if(gtk_widget_get_toplevel(GTK_WIDGET(button))==DirTo){
	DirTo=NULL;
	getcwd(cwd,sizeof(cwd));
	gtk_label_set_text(GTK_LABEL(lblTo),cwd);
  }
  if(gtk_widget_get_toplevel(GTK_WIDGET(button))==TempDir){
	TempDir=NULL;
	getcwd(cwd,sizeof(cwd));
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(Options,"inpZipTempDir")),cwd);	
  }
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
  selFrom->numrows=compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  for(i=0;i<selFrom->numrows;i++)
	selFrom[i].row=(int*)0;
  gdk_threads_leave();
}


void
on_btnOpenDirectoryCancel_button_press_event
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(gtk_widget_get_toplevel(GTK_WIDGET(button))==DirFrom)
	DirFrom=NULL;
  if(gtk_widget_get_toplevel(GTK_WIDGET(button))==DirTo)
	DirTo=NULL;
  if(gtk_widget_get_toplevel(GTK_WIDGET(button))==DirTo)
	TempDir=NULL;
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


gboolean
on_lstDirectories_button_press_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_fselOk_button_press_event           (GtkButton       *button,
                                        gpointer         user_data)
{
  char *saveas;
  if(FileOpenZipExe!=NULL){
	strcpy(methods.zip.Exe,gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileOpenZipExe)));
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(Options,"inpZipExe")),methods.zip.Exe);
	gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));  
	FileOpenZipExe=NULL;
  }	
  if(FileOpenGzipExe!=NULL){
	strcpy(methods.gzip.Exe,gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileOpenGzipExe)));
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(Options,"inpGzipExe")),methods.gzip.Exe);
	gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));  
	FileOpenGzipExe=NULL;
  }	
  if(FileOpenBzipExe!=NULL){
	strcpy(methods.bzip.Exe,gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileOpenBzipExe)));
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(Options,"inpBzipExe")),methods.bzip.Exe);
	gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));  
	FileOpenBzipExe=NULL;
  }	
  if(FileOpenTarExe!=NULL){
	strcpy(methods.tar.Exe,gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileOpenTarExe)));
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(Options,"inpTarExe")),methods.tar.Exe);
	gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));  
	FileOpenTarExe=NULL;
  }	
  if(FileOpenUxExe!=NULL){
	strcpy(methods.ux.Exe,gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileOpenUxExe)));
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(Options,"inpUxExe")),methods.ux.Exe);
	gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));  
	FileOpenUxExe=NULL;
  }	
  if(FileSaveAs!=NULL){
	char *temp;
	gdk_threads_enter();
	temp=gtk_file_selection_get_filename(GTK_FILE_SELECTION(FileSaveAs));
	saveas=(char*)malloc(strlen(temp));
	strcpy(saveas,temp);
	gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));  
	FileSaveAs=NULL;
	Progress=create_winProgress();
	gtk_progress_configure(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),0,0,(gfloat)selTo->numrows);
	gtk_widget_show_now(Progress);
	if(!strcmp(method,"Zip"))
	    zipCompress(saveas);
	if(!strcmp(method,"Bzip2"))
	    bzipCompress(saveas);
	if(!strcmp(method,"Gzip"))
	    gzipCompress(saveas);
	if(!strcmp(method,"Unix Compress"))
	    uxCompress(saveas);
	if(!strcmp(method,"Tar")){
	    strcat(saveas,".tar");
	    tarCompress(saveas);
	}
	if(!strcmp(method,"Tar + Gzip")){
	    strcat(saveas,".tar");
	    tarCompress(saveas);
	    targzipCompress(saveas);
	}
	if(!strcmp(method,"Tar + Bzip2")){
	    strcat(saveas,".tar");
	    tarCompress(saveas);
	    bzipCompress(saveas);
	}
	if(!strcmp(method,"Tar + Unix Compress")){
	    strcat(saveas,".tar");
	    tarCompress(saveas);
	    uxCompress(saveas);
	}
	free(method);
	gdk_threads_leave();
  }	
}

void
on_fselCancel_button_press_event       (GtkButton       *button,
                                        gpointer         user_data)
{
  FileSaveAs=NULL;
  FileOpenZipExe=NULL;
  FileOpenGzipExe=NULL;
  FileOpenBzipExe=NULL;
  FileOpenTarExe=NULL;
  FileOpenUxExe=NULL;
  free(method);
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


void
on_popChangeDirectoryFrom_activate_current
                                        (GtkMenuShell    *menushell,
                                        gboolean         force_hide,
                                        gpointer         user_data)
{

}


void
on_popChangeDirectoryFrom_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char cwd[1024];
  gdk_threads_enter();
  if(DirFrom==NULL)
	DirFrom=create_winOpenDirectory();
  getcwd(cwd,sizeof(cwd));
  getOpenDir(1,cwd,DirFrom,"DirFrom",0);
  gtk_window_set_title(GTK_WINDOW(DirFrom),_("Open Directory From"));
  gtk_widget_show(DirFrom);
  gdk_threads_leave();
}


void
on_btndlgOk_button_press_event         (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


void
on_btndlgCancel_button_press_event     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


void
on_btnProgressCancel_button_press_event
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  cancelled=1;
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


void
on_btnOptionsSave_button_press_event   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget* errMessage=NULL;
  GtkWidget* txtMessage=NULL;
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  getOptions((GtkWidget*)button);
  writeFile();
  if(methods.zip.Intern!=0){
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ZERR_MSG00,strlen(ZERR_MSG00));
	gtk_widget_show(errMessage);
	goto end;
  }
  if(strlen(methods.zip.Exe)!=0){
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
	Options=NULL;
  }else{
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ZERR_MSG01,strlen(ZERR_MSG01));
	gtk_widget_show(errMessage);
	goto end;
  }
  if(methods.gzip.Intern!=0){
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG00,strlen(GZERR_MSG00));
	gtk_widget_show(errMessage);
	goto end;
  }
  if(strlen(methods.gzip.Exe)!=0){
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
	Options=NULL;
  }else{
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG01,strlen(GZERR_MSG01));
	gtk_widget_show(errMessage);
	goto end;
  }
  if(methods.ux.Intern!=0){
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG00,strlen(GZERR_MSG00));
	gtk_widget_show(errMessage);
	goto end;
  }
  if(strlen(methods.ux.Exe)!=0){
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
	Options=NULL;
  }else{
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG01,strlen(GZERR_MSG01));
	gtk_widget_show(errMessage);
	goto end;
  }
  if(methods.tar.Intern!=0){
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG00,strlen(GZERR_MSG00));
	gtk_widget_show(errMessage);
	goto end;
  }
  if(strlen(methods.tar.Exe)!=0){
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
	Options=NULL;
  }else{
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,GZERR_MSG01,strlen(GZERR_MSG01));
	gtk_widget_show(errMessage);
	goto end;
  }
end:
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
    Options=NULL;
}

void
optCompressionChanged	(gchar *string){
  gdk_threads_enter();
  method=(char*)malloc(strlen(string));
  strncpy(method,string,strlen(string));
  gdk_threads_leave();
}

void
optItemChangedFrom	(gchar *string){
  GtkWidget* inpDirectory=NULL;
  gdk_threads_enter();
  inpDirectory=lookup_widget(GTK_WIDGET(DirFrom),"inpDirectory");
  getOpenDir(1,string,DirFrom,"DirFrom",0);
  gtk_entry_set_text(GTK_ENTRY(inpDirectory),"");
  gdk_threads_leave();
}

void
optItemChangedTemp  (gchar *string){
  GtkWidget* inpDirectory=NULL;
  gdk_threads_enter();
  inpDirectory=lookup_widget(GTK_WIDGET(TempDir),"inpDirectory");
  getOpenDir(1,string,TempDir,"TempDir",0);
  gtk_entry_set_text(GTK_ENTRY(inpDirectory),"");
  gdk_threads_leave();
}

void
optItemChangedTo	(gchar *string){
  GtkWidget* inpDirectory=NULL;
  gdk_threads_enter();
  inpDirectory=lookup_widget(GTK_WIDGET(DirTo),"inpDirectory");
  getOpenDir(1,string,DirTo,"DirTo",0);
  gtk_entry_set_text(GTK_ENTRY(inpDirectory),"");
  gdk_threads_leave();
}

void
on_lstFrom_click_column                (GtkCList        *clist,
                                        gint             column,
                                        gpointer         user_data)
{
  char cwd[1024];
  gdk_threads_enter();
  getcwd(cwd,sizeof(cwd));
  if(column==0)
	getFromDir(0,cwd,winMain,"winMain",0);
  if(column==1)
	getFromDir(0,cwd,winMain,"winMain",1);	
  gdk_threads_leave();
}


void
on_lstDirectories_select_row           (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  GtkWidget* inpDirectory=NULL;
  char *cwd="",temp[1024];
  gdk_threads_enter();
  inpDirectory=lookup_widget(GTK_WIDGET(clist),"inpDirectory");
  getcwd(temp,sizeof(temp));
  if(strcmp(temp,"/"))
	strcat(temp,"/");
  gtk_clist_get_text(clist,row,column,&cwd);
  strcat(temp,cwd);
  strcat(temp,"/");
  gtk_entry_set_text(GTK_ENTRY(inpDirectory),temp);
  gdk_threads_leave();
}


void
on_popChangeDirectoryTo_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char cwd[1024];
  gdk_threads_enter();
  if(DirTo==NULL)
	DirTo=create_winOpenDirectory();
  getcwd(cwd,sizeof(cwd));
  getOpenDir(1,cwd,DirTo,"DirTo",0);
  gtk_window_set_title(GTK_WINDOW(DirTo),_("Open Directory To"));
  gtk_widget_show(DirTo);
  gdk_threads_leave();
}


void
on_lstTo_click_column                  (GtkCList        *clist,
                                        gint             column,
                                        gpointer         user_data)
{

}


gboolean
on_lstTo_button_press_event            (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  GtkWidget* popup=NULL;
  popup=create_popChangeDirectoryTo();
  if(event->type==GDK_BUTTON_PRESS &&
	 event->button==3){
	gtk_menu_popup(GTK_MENU(popup),NULL,NULL,NULL,NULL,
				   event->button,event->time);
  }
  return FALSE;
}


void
on_popChangeDirectoryTo_activate_current
                                        (GtkMenuShell    *menushell,
                                        gboolean         force_hide,
                                        gpointer         user_data)
{

}


gboolean
on_inpDirectory_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_inpDirectory_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
  char cwd[1024],*temp;
  int len=0;
  temp=gtk_entry_get_text(GTK_ENTRY(editable));
  strcpy(cwd,temp);
  len=strlen(cwd);
  if(!strcmp(&cwd[strlen(cwd)-1],"/")){
	if(DirFrom!=NULL)
	  getOpenDir(1,cwd,DirFrom,"DirFrom",0);
	if(DirTo!=NULL)
	  getOpenDir(1,cwd,DirTo,"DirTo",0);
	if(TempDir!=NULL)
	  getOpenDir(1,cwd,TempDir,"TempDir",0);
  }  
}


gboolean
on_btnRemoveAll_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  GtkWidget* lstFrom=NULL;
  GtkWidget* lstTo=NULL;
  int i;
  char cwd[1024];
  lstFrom=lookup_widget(widget,"lstFrom");
  lstTo=lookup_widget(widget,"lstTo");
  gtk_clist_select_all(GTK_CLIST(lstTo));
  gtk_clist_clear(GTK_CLIST(lstTo));
  memset(selFrom,0x0,sizeof(selFrom));
  getcwd(cwd,sizeof(cwd));
  getFromDir(0,cwd,winMain,"winMain",0);
  selFrom->numrows=compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  for(i=0;i<selFrom->numrows;i++)
	selFrom[i].row=0;
  selTo->numrows=compareLists((GtkCList*)lstTo,(GtkCList*)lstFrom);
  for(i=0;i<selTo->numrows;i++)
	if(selTo[i].row!=(int*)1)
	  selTo[i].row=0;
  compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  return FALSE;
}

void
on_lstFrom_select_row                  (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  char cwd[1024],*buffer;
  char *sts=(char*)malloc(256);
  int i=0,j=0;
  GtkWidget* lstFrom=NULL;
  GtkWidget* lstTo=NULL;
  GtkWidget* errMessage=NULL;
  GtkWidget* txtMessage=NULL;
  lstFrom=lookup_widget(GTK_WIDGET(clist),"lstFrom");
  lstTo=lookup_widget(GTK_WIDGET(clist),"lstTo");
  gtk_clist_get_text(clist,row,0,&buffer);
  if((event!=0)&&(event->type==GDK_2BUTTON_PRESS)){
	event->type=GDK_BUTTON_PRESS;
	if(chdir(buffer)){
	  errMessage=create_dlgMessage();
	  txtMessage=lookup_widget(errMessage,"txtMessage");
	  gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG05,strlen(ERR_MSG05));
	  gtk_widget_show(errMessage);
	}else{
	  getcwd(cwd,sizeof(cwd));
	  getFromDir(0,cwd,winMain,"winMain",0);
	  selFrom->numrows=compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
	  for(i=0;i<selFrom->numrows;i++)
		selFrom[i].row=(int*)0;
	  selTo->numrows=compareLists((GtkCList*)lstTo,(GtkCList*)lstFrom);
	  for(i=0;i<selTo->numrows;i++)
		if(selTo[i].row!=(int*)1)
		  selTo[i].row=(int*)0;
	}
  }else{
    if(!strcmp(buffer,"../"))
	  selFrom[0].row=(int*)0;
	else
	  selFrom[row].row=(int*)1;
	j=0;
	for(i=0;i<selFrom->numrows;i++)
	  if(selFrom[i].row==(int*)1)
		j++;
	sprintf(sts,"Listed Files : %d Selected Files : %d",selFrom->numrows,j);
	gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(winMain,"stsFrom")),GPOINTER_TO_INT(
	gtk_statusbar_get_context_id(GTK_STATUSBAR(lookup_widget(winMain,"stsFrom")),"stsFrom")),sts);
//	free(sts);
  }
}


void
on_lstFrom_unselect_row                (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  char *sts=(char*)malloc(256);
  int i=0,j=0;
  selFrom[row].row=(int*)0;
  j=0;
  for(i=0;i<selFrom->numrows;i++)
	if(selFrom[i].row==(int*)1)
	  j++;
  sprintf(sts,"Listed Files : %d Selected Files : %d",selFrom->numrows,j);
  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(winMain,"stsFrom")),GPOINTER_TO_INT(
  gtk_statusbar_get_context_id(GTK_STATUSBAR(lookup_widget(winMain,"stsFrom")),"stsFrom")),sts);
//  free(sts);
}

void
on_lstTo_select_row                    (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  char *sts=(char*)malloc(256);
  int i=0,j=0;
  selTo[row].row=(int*)1;
  j=0;
  for(i=0;i<selTo->numrows;i++)
	if(selTo[i].row==(int*)1)
	  j++;
  sprintf(sts,"Listed Files : %d Selected Files : %d",selTo->numrows,j);
  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(winMain,"stsTo")),GPOINTER_TO_INT(
  gtk_statusbar_get_context_id(GTK_STATUSBAR(lookup_widget(winMain,"stsTo")),"stsTo")),sts);
//  free(sts);
}


void
on_lstTo_unselect_row                  (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  char *sts=(char*)malloc(256);
  int i=0,j=0;
  selTo[row].row=(int*)0;
  j=0;
  for(i=0;i<selTo->numrows;i++)
	if(selTo[i].row==(int*)1)
	  j++;
  sprintf(sts,"Listed Files : %d Selected Files : %d",selTo->numrows,j);
  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(winMain,"stsTo")),GPOINTER_TO_INT(
  gtk_statusbar_get_context_id(GTK_STATUSBAR(lookup_widget(winMain,"stsTo")),"stsTo")),sts);
//  free(sts);
}


gboolean
on_lstFrom_event                       (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  return FALSE;
}


gboolean
on_lstTo_event                         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  return FALSE;
}


void
on_winMain_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
  GtkWidget* lstFrom=NULL;
  GtkWidget* lstTo=NULL;
  char cwd[1024];
  int i;
  lstFrom=lookup_widget(widget,"lstFrom");
  lstTo=lookup_widget(widget,"lstTo");
  getcwd(cwd,sizeof(cwd));
  getFromDir(0,cwd,winMain,"winMain",0);
  memset(selFrom,0x0,sizeof(selFrom));
  selFrom->numrows=compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  for(i=0;i<selFrom->numrows;i++)
    selFrom[i].row=(int*)0;
  selTo->numrows=compareLists((GtkCList*)lstTo,(GtkCList*)lstFrom);
  for(i=0;i<selTo->numrows;i++)
    if(selTo[i].row!=(int*)1)
      selTo[i].row=(int*)0;
  compareLists((GtkCList*)lstFrom,(GtkCList*)lstTo);
  compareLists((GtkCList*)lstTo,(GtkCList*)lstFrom);
  readFile();
  GTK_CHECK_MENU_ITEM(lookup_widget(winMain,"mnuOptionsTooltips"))->active=methods.toolTips;
}


void
on_btnOptionsCancel_button_press_event (GtkButton       *button,
                                        gpointer         user_data)
{
  Options=NULL;
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


void
on_mnuOptionsTooltips_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget* options=NULL;
  options=create_winOptions();
  methods.toolTips=(char)GTK_CHECK_MENU_ITEM(menuitem)->active;
  getOptions(options);
  writeFile();
}

void getOptions(GtkWidget* widget){
  GtkRange *temp=NULL;
  GtkAdjustment *adj=NULL;
  methods.toolTips=(char)GTK_CHECK_MENU_ITEM(lookup_widget(winMain,"mnuOptionsTooltips"))->active;
  //Zip options
  methods.zip.Intern=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipIntern"))->active;
  memset(methods.zip.Exe,0x0,sizeof(methods.zip.Exe));
  strcpy(methods.zip.Exe,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpZipExe"))));
  temp=(GtkRange*)lookup_widget(widget,"sldZipLevel");
  adj=gtk_range_get_adjustment(temp);
  methods.zip.CompLevel=(int)adj->value;
  methods.zip.Store=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipStore"))->active;
  methods.zip.RecTop=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipRecTop"))->active;
  methods.zip.XtraAttr=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipXtraAttr"))->active;
  methods.zip.RecCur=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipRecCur"))->active;
  methods.zip.DirEntries=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipDirEntries"))->active;
  methods.zip.AsLink=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipAsLink"))->active;
/*  methods.zip.CrLfLf=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipCrLfLf"))->active;
  methods.zip.LfCrLf=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipLfCrLf"))->active;*/
  methods.zip.Grow=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipGrow"))->active;
  methods.zip.DirNames=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipDirNames"))->active;
  methods.zip.TestInt=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipTestInt"))->active;
  methods.zip.Pkzip=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipPkzip"))->active;
  methods.zip.MvFiles=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipMvFiles"))->active;
  methods.zip.TempDir=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipTempDir"))->active;
  memset(methods.zip.TempDirName,0x0,sizeof(methods.zip.TempDirName));
  strcpy(methods.zip.TempDirName,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpZipTempDir"))));
  methods.zip.AddComment=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipAddComment"))->active;
  memset(methods.zip.ZipComment,0x0,sizeof(methods.zip.ZipComment));
  strcpy(methods.zip.ZipComment,
		 gtk_editable_get_chars(GTK_EDITABLE(lookup_widget(widget,"txtZipComment")),0,
		 gtk_text_get_length(GTK_TEXT(lookup_widget(widget,"txtZipComment")))));
  //Gzip options
  methods.gzip.Intern=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipIntern"))->active;
  memset(methods.gzip.Exe,0x0,sizeof(methods.gzip.Exe));
  strcpy(methods.gzip.Exe,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpGzipExe"))));
  temp=(GtkRange*)lookup_widget(widget,"sldGzipLevel");
  adj=gtk_range_get_adjustment(temp);
  methods.gzip.CompLevel=(int)adj->value;
  methods.gzip.Store=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipStore"))->active;
  methods.gzip.WriteOverOut=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipWriteOverOut"))->active;
  methods.gzip.TestInt=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipTestInt"))->active;
  methods.gzip.RecThru=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipRecThru"))->active;
  methods.gzip.KeepInput=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipKeepInput"))->active;
  methods.gzip.AltSuf=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipAltSuf"))->active;
  memset(methods.gzip.Suffix,0x0,sizeof(methods.gzip.Suffix));
  strcpy(methods.gzip.Suffix,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpGzipAltSuf"))));  
  //Bzip options
  methods.bzip.Intern=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipIntern"))->active;
  memset(methods.bzip.Exe,0x0,sizeof(methods.bzip.Exe));
  strcpy(methods.bzip.Exe,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpBzipExe"))));
  temp=(GtkRange*)lookup_widget(widget,"sldGzipLevel");
  adj=gtk_range_get_adjustment(temp);
  methods.bzip.CompLevel=(int)adj->value;
  methods.bzip.Store=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipStore"))->active;
  methods.bzip.ForceComp=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipForceComp"))->active;
  methods.bzip.KeepInput=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipKeepInput"))->active;
  methods.bzip.WriteOverOut=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipWriteOverOut"))->active;
  methods.bzip.TestInt=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipTestInt"))->active;
  methods.bzip.RedMem=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipLessMem"))->active;
  //Unix Compress options
  methods.ux.Intern=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnUxIntern"))->active;
  memset(methods.ux.Exe,0x0,sizeof(methods.ux.Exe));
  strcpy(methods.ux.Exe,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpUxExe"))));
  temp=(GtkRange*)lookup_widget(widget,"sldUxLevel");
  adj=gtk_range_get_adjustment(temp);
  methods.ux.CompLevel=(int)adj->value;
  methods.ux.RecThru=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnUxRecThru"))->active;
  methods.ux.WriteOverOut=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnUxWriteOverOut"))->active;
  //Tar options
  methods.tar.Intern=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarIntern"))->active;
  memset(methods.tar.Exe,0x0,sizeof(methods.tar.Exe));
  strcpy(methods.tar.Exe,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpTarExe"))));
  methods.tar.Verify=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarVerify"))->active;
  methods.tar.FailRead=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarFailRead"))->active;
  methods.tar.ForceOwner=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarForceOwner"))->active;
  memset(methods.tar.Owner,0x0,sizeof(methods.tar.Owner));
  strcpy(methods.tar.Owner,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpTarOwner"))));
  methods.tar.ForceGroup=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarForceGroup"))->active;
  memset(methods.tar.Group,0x0,sizeof(methods.tar.Group));
  strcpy(methods.tar.Group,gtk_entry_get_text(GTK_ENTRY(lookup_widget(widget,"inpTarGroup"))));
  methods.tar.IgnoreZero=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarIgnoreZero"))->active;
  methods.tar.AbsNames=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarAbsNames"))->active;
  methods.tar.PosixArchive=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarPosixArchive"))->active;
  methods.tar.V7Archive=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarV7Archive"))->active;
  methods.tar.NewFormat=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarNewFormat"))->active;
  methods.tar.OldFormat=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarOldFormat"))->active;
  methods.tar.DerefLinks=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarDerefLinks"))->active;
  methods.tar.RecThru=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarRecThru"))->active;
  methods.tar.Local=(char)GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarLocal"))->active;
}

void setOptions(GtkWidget* widget){
  GtkRange *temp=NULL;
  GtkAdjustment *adj=NULL;
  GTK_CHECK_MENU_ITEM(lookup_widget(winMain,"mnuOptionsTooltips"))->active=methods.toolTips;
  //Zip options
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipIntern"))->active=methods.zip.Intern;
  if(methods.zip.Exe!=NULL)
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpZipExe")),methods.zip.Exe);
  temp=(GtkRange*)lookup_widget(widget,"sldZipLevel");
  adj=gtk_range_get_adjustment(temp);
  adj->value=methods.zip.CompLevel;
  if(methods.zip.Store==0)
	gtk_range_set_adjustment(temp,adj);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipStore"))->active=methods.zip.Store;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipRecTop"))->active=methods.zip.RecTop;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipXtraAttr"))->active=methods.zip.XtraAttr;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipRecCur"))->active=methods.zip.RecCur;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipDirEntries"))->active=methods.zip.DirEntries;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipAsLink"))->active=methods.zip.AsLink;
/*  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipCrLfLf"))->active=methods.zip.CrLfLf;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipLfCrLf"))->active=methods.zip.LfCrLf;*/
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipGrow"))->active=methods.zip.Grow;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipDirNames"))->active=methods.zip.DirNames;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipTestInt"))->active=methods.zip.TestInt;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipPkzip"))->active=methods.zip.Pkzip;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipMvFiles"))->active=methods.zip.MvFiles;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipTempDir"))->active=methods.zip.TempDir;
  if(methods.zip.TempDirName!=NULL)
  	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpZipTempDir")),methods.zip.TempDirName);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnZipAddComment"))->active=methods.zip.AddComment;
  gtk_text_insert(GTK_TEXT(lookup_widget(widget,"txtZipComment")),NULL,NULL,NULL,methods.zip.ZipComment,
				  strlen(methods.zip.ZipComment));
  //Gzip options
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipIntern"))->active=methods.gzip.Intern;
  if(methods.gzip.Exe!=NULL)
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpGzipExe")),methods.gzip.Exe);
  temp=(GtkRange*)lookup_widget(widget,"sldGzipLevel");
  adj=gtk_range_get_adjustment(temp);
  adj->value=methods.gzip.CompLevel;
  if(methods.gzip.Store==0)
	gtk_range_set_adjustment(temp,adj);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipStore"))->active=methods.gzip.Store;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipWriteOverOut"))->active=methods.gzip.WriteOverOut;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipTestInt"))->active=methods.gzip.TestInt;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipRecThru"))->active=methods.gzip.RecThru;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipKeepInput"))->active=methods.gzip.KeepInput;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnGzipAltSuf"))->active=methods.gzip.AltSuf;
  if(methods.gzip.Suffix!=NULL)
  	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpGzipAltSuf")),methods.gzip.Suffix);
  //Bzip options
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipIntern"))->active=methods.bzip.Intern;
  if(methods.bzip.Exe!=NULL)
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpBzipExe")),methods.bzip.Exe);
  temp=(GtkRange*)lookup_widget(widget,"sldBzipLevel");
  adj=gtk_range_get_adjustment(temp);
  adj->value=methods.bzip.CompLevel;
  if(methods.bzip.Store==0)
	gtk_range_set_adjustment(temp,adj);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipStore"))->active=methods.bzip.Store;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipForceComp"))->active=methods.bzip.ForceComp;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipKeepInput"))->active=methods.bzip.KeepInput;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipWriteOverOut"))->active=methods.bzip.WriteOverOut;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipTestInt"))->active=methods.bzip.TestInt;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnBzipLessMem"))->active=methods.bzip.RedMem;
  //Unix Compress options
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnUxIntern"))->active=methods.ux.Intern;
  if(methods.ux.Exe!=NULL)
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpUxExe")),methods.ux.Exe);
  temp=(GtkRange*)lookup_widget(widget,"sldUxLevel");
  adj=gtk_range_get_adjustment(temp);
  adj->value=methods.ux.CompLevel;
  gtk_range_set_adjustment(temp,adj);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnUxRecThru"))->active=methods.ux.RecThru;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnUxWriteOverOut"))->active=methods.ux.WriteOverOut;
  //Tar options
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarIntern"))->active=methods.tar.Intern;
  if(methods.tar.Exe!=NULL)
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpTarExe")),methods.tar.Exe);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarVerify"))->active=methods.tar.Verify;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarFailRead"))->active=methods.tar.FailRead;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarForceOwner"))->active=methods.tar.ForceOwner;
  if(methods.tar.Owner!=NULL)
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpTarOwner")),methods.tar.Owner);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarForceGroup"))->active=methods.tar.ForceGroup;
  if(methods.tar.Group!=NULL)
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(widget,"inpTarGroup")),methods.tar.Group);
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarIgnoreZero"))->active=methods.tar.IgnoreZero;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarAbsNames"))->active=methods.tar.AbsNames;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarPosixArchive"))->active=methods.tar.PosixArchive;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarV7Archive"))->active=methods.tar.V7Archive;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarNewFormat"))->active=methods.tar.NewFormat;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarOldFormat"))->active=methods.tar.OldFormat;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarDerefLinks"))->active=methods.tar.DerefLinks;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarRecThru"))->active=methods.tar.RecThru;
  GTK_TOGGLE_BUTTON(lookup_widget(widget,"btnTarLocal"))->active=methods.tar.Local;
}

void
on_btnZipBrowse_pressed                (GtkButton       *button,
                                        gpointer         user_data)
{
  gdk_threads_enter();
  if(FileOpenZipExe==NULL)
	FileOpenZipExe=create_fileSaveAs();
  gtk_window_set_title(GTK_WINDOW(FileOpenZipExe),_("Open Zip Executable"));
//  FileOpenZipExe->name="FileOpenZipExe";
  gtk_widget_show(FileOpenZipExe);
  gdk_threads_leave();
}


void
on_btnZipTempBrowse_pressed            (GtkButton       *button,
                                        gpointer         user_data)
{
  char cwd[1024];
  gdk_threads_enter();
  if(TempDir==NULL)
	TempDir=create_winOpenDirectory();
  getcwd(cwd,sizeof(cwd));
  getOpenDir(1,cwd,TempDir,"TempDir",0);
  gtk_window_set_title(GTK_WINDOW(TempDir),_("Choose the temp directory"));
  gtk_widget_show(TempDir);
  gdk_threads_leave();
}


void
on_btnGzipBrowse_pressed               (GtkButton       *button,
                                        gpointer         user_data)
{
  gdk_threads_enter();
  if(FileOpenGzipExe==NULL)
	FileOpenGzipExe=create_fileSaveAs();
  gtk_window_set_title(GTK_WINDOW(FileOpenGzipExe),_("Open Gzip Executable"));
  FileOpenGzipExe->name="FileOpenGzipExe";
  gtk_widget_show(FileOpenGzipExe);
  gdk_threads_leave();
}


void
on_btnBzipBrowse_pressed               (GtkButton       *button,
                                        gpointer         user_data)
{
  gdk_threads_enter();
  if(FileOpenBzipExe==NULL)
	FileOpenBzipExe=create_fileSaveAs();
  gtk_window_set_title(GTK_WINDOW(FileOpenBzipExe),_("Open Bzip Executable"));
  FileOpenBzipExe->name="FileOpenBzipExe";
  gtk_widget_show(FileOpenBzipExe);
  gdk_threads_leave();
}


void
on_btnUxBrowse_pressed                 (GtkButton       *button,
                                        gpointer         user_data)
{
  gdk_threads_enter();
  if(FileOpenUxExe==NULL)
	FileOpenUxExe=create_fileSaveAs();
  gtk_window_set_title(GTK_WINDOW(FileOpenUxExe),_("Open Unix Compress Executable"));
  FileOpenUxExe->name="FileOpenUxExe";
  gtk_widget_show(FileOpenUxExe);
  gdk_threads_leave();
}


void
on_btnTarBrowse_pressed                (GtkButton       *button,
                                        gpointer         user_data)
{
  gdk_threads_enter();
  if(FileOpenTarExe==NULL)
	FileOpenTarExe=create_fileSaveAs();
  gtk_window_set_title(GTK_WINDOW(FileOpenTarExe),_("Open Tar Executable"));
  FileOpenTarExe->name="FileOpenTarExe";
  gtk_widget_show(FileOpenTarExe);
  gdk_threads_leave();
}


void
on_btnProgressClose_pressed            (GtkButton       *button,
                                        gpointer         user_data)
{
//  cancelled=0;
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


void
on_btnProgressDone_pressed             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

